#!/usr/bin/ksh

#-----------------------------------------------------------------------------------------
#--
#-- Copyright (c) 2009-2012 ProactiveRA
#--
#-- This script is free software; you can redistribute it and/or modify it under
#-- the terms of the GNU Lesser General Public License as published by the Free
#-- Software Foundation; either version 3 of the License, or (at your option)
#-- any later version.
#--
#-- This script is distributed in the hope that it will be useful, but WITHOUT
#-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
#-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
#-- details.
#--
#-- You should have received a copy of the GNU Lesser General Public License
#-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
#--
#-----------------------------------------------------------------------------------------

ra_user=`whoami`
process_id=`ps -efl | grep ${ra_user} | grep cron_CDR | grep -v grep  | awk '{print $4}'`
if [[ "${process_id}" -ne "" ]]; then
        echo "RA Process is running (cron_CDR)!"
        echo "   process id: ${process_id}"
        echo "Shutting it down..."
	`kill ${process_id}`
	sleep 2
        killed_process_id="${process_id}"
        nb_attempts=0
        while [[ ("${killed_process_id}" -ne "") && (nb_attempts -le 10) ]]; do
          echo "Checking if the shutdown was successful..."
          killed_process_id=`ps -efl | grep ${ra_user} | grep cron_CDR | grep -v grep  | awk '{print $4}'`
          if [[ "${killed_process_id}" -ne "" ]]; then
                echo "Process is still up... Killing it now"
                `kill ${killed_process_id}`
                sleep 5
                killed_process_id=`ps -efl | grep ${ra_user} | grep cron_CDR | grep -v grep  | awk '{print $4}'`
          fi
          ((nb_attempts=nb_attempts+1))
        done
fi
process_id=`ps -efl | grep ${ra_user} | grep cron_CDR | grep -v grep  | awk '{print $4}'`
if [[ "${process_id}" -ne "" ]]; then
  echo "Can't shutdown the RA Process (cron_CDR)..."
  echo "Exiting"
  exit
fi
echo "Process is down (cron_CDR)..."
