#!/usr/bin/ksh

#-----------------------------------------------------------------------------------------
#--
#-- Copyright (c) 2009-2012 ProactiveRA
#--
#-- This script is free software; you can redistribute it and/or modify it under
#-- the terms of the GNU Lesser General Public License as published by the Free
#-- Software Foundation; either version 3 of the License, or (at your option)
#-- any later version.
#--
#-- This script is distributed in the hope that it will be useful, but WITHOUT
#-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
#-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
#-- details.
#--
#-- You should have received a copy of the GNU Lesser General Public License
#-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
#--
#-----------------------------------------------------------------------------------------

. ../Common/lib.ksh

function cron_RA {

day=$(date +%Y%m%d)
read_cron_file
calculate_next_date 1
tomorrow=${calculated_day}

i=1
while [[ $i -le $nb_tasks ]]; do
  task_nextexecdate[$i]=$tomorrow
  i=$i+1
done

previous_day=0

while [ 1 -ne 0 ]
do
  # Get current time
  time=$(date +%H%M)
  day=$(date +%Y%m%d)

  if [ $day -ne $previous_day ]
  then
        # Prepare name of the log file
        previous_day=$day
        date=$(date +%Y%m%d_%H%M%S)
        logfile=${logfile_dir}/cron_${MODULE}_${date}.log
        touch $logfile
  fi

  task=1
  while [[ $task -le $nb_tasks ]]; do
        if [[ ${task_time[$task]} -le $time ]]; then
                if [[ ${task_nextexecdate[$task]} -eq $day ]]; then
                        #Launch the command in the background
                        echo "[$time] Launching: ${task_command[$task]}"
                        echo "[$time] Launching: ${task_command[$task]}" >> $logfile
                        ${task_command[$task]} &
                        calculate_next_date ${task_frequency[$task]}
                        task_nextexecdate[$task]=${calculated_day};
                        echo "[$time] >> Next execution time: ${calculated_day}"
                        echo "[$time] >> Next execution time: ${calculated_day}" >> $logfile
                fi
        fi
        (( task += 1 ))
  done
  sleep 60;
done

}
