#!/usr/bin/ksh

#-----------------------------------------------------------------------------------------
#--
#-- Copyright (c) 2009-2012 ProactiveRA
#--
#-- This script is free software; you can redistribute it and/or modify it under
#-- the terms of the GNU Lesser General Public License as published by the Free
#-- Software Foundation; either version 3 of the License, or (at your option)
#-- any later version.
#--
#-- This script is distributed in the hope that it will be useful, but WITHOUT
#-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
#-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
#-- details.
#--
#-- You should have received a copy of the GNU Lesser General Public License
#-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
#--
#-----------------------------------------------------------------------------------------


function extract_dir_remote {

  #----------------------------------------------------------------------
  #-- Extract proc to be used when the CDR files are on the same server 
  #-- as the RA system, but not in a directory owned by RA
  #-- (i.e. files can't be moved from the initial directory by the script)
  #----------------------------------------------------------------------
  #--
  #-- Parameters required in the resource file:
  #--      source-directory: directory where files are located
  #--
  #----------------------------------------------------------------------

  file_pattern=$2
  for myfile in $(ls -1d ${source_directory[$1]}/${file_pattern} 2> /dev/null); do
  	if [[ -d  $myfile ]];then
        	# This is a directory.. skip
                 unused=1
        else
		 copy=1
		 file_name=`echo $myfile | sed 's/.*\///'`

		 if [ $MODULE = "CDR" ]; then
                 	# See if it has been processed already or not...
                 	result=`grep ${file_name} ${extracted_dir}/${main_directory[$1]}/processed/${my_extracted_files}`
                 	if [ "$result" ]
                 	then
                        	# File Already extracted..move to to_delete 
                        	mv $myfile ${extracted_dir}/${main_directory[$1]}/to_delete
				copy=0
                 	fi
		 fi
		 if [ $copy = 1 ]; then
                        # New File - Continue
                        ((nb_file=nb_file+1))
                        echo "  [${file_name}]"
                        echo "  [${file_name}]" >> $logfile

                        # Copying the file to the 'extracted' directory
                        cp $myfile ${extracted_cdr_dir}/${main_directory[$1]}

			# Moving the file to 'raw/ready' directory
			mv ${extracted_cdr_dir}/${main_directory[$1]}/${file_name} ${ready_dir}/${main_directory[$1]}
                        echo "    => File moved to 'raw/ready' directory"
                        echo "    => File moved to 'raw/ready' directory" >> $logfile

			# Registering the file collected
		        if [ $MODULE = "CDR" ]; then
                        	echo "${file_name}" >> ${extracted_dir}/${main_directory[$1]}/processed/${my_extracted_files}
			fi
                 fi
        fi
  done

}

