#!/usr/bin/ksh

#-----------------------------------------------------------------------------------------
#--
#-- Copyright (c) 2009-2012 ProactiveRA
#--
#-- This script is free software; you can redistribute it and/or modify it under
#-- the terms of the GNU Lesser General Public License as published by the Free
#-- Software Foundation; either version 3 of the License, or (at your option)
#-- any later version.
#--
#-- This script is distributed in the hope that it will be useful, but WITHOUT
#-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
#-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
#-- details.
#--
#-- You should have received a copy of the GNU Lesser General Public License
#-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
#--
#-----------------------------------------------------------------------------------------

function scan_logfiles {

# Prepare name of the log file
date=$(date +%Y%m%d_%H%M%S)
logfile=${logfile_dir}/scan_${MODULE}_logs_${date}.log
touch $logfile

MAILTO="info@proactiveRA.com"
errorfound=0

echo "======================================================="
echo "=======================================================" >> $logfile
echo " Starting the scan of the logfiles"
echo " Starting the scan of the logfiles" >> $logfile
echo "======================================================="
echo "=======================================================" >> $logfile

for myfile in $(find ${logfile_dir} -mtime -2 ! \( -name 'scan*' -o -name 'launch*' \) ); do
     LogHasError=0
     if [[ -d  $myfile ]];then
        # This is a directory.. skip
        unused=1
     else
        result=`grep 'ORA-' $myfile`
        if [ "$result" ]
        then
            LogHasError=1
        else
            result=`grep 'SP2-' $myfile`
            if [ "$result" ]
            then
                LogHasError=1
            else
                result=`grep 'ERROR[^E]' $myfile`
                if [ "$result" ]
                then
                        LogHasError=1
                else
                        result=`grep 'ERROR$' $myfile`
                        if [ "$result" ]
                        then
                                LogHasError=1
                        fi
                fi
            fi
        fi
        if [ $LogHasError = 1 ]
        then
            errorfound=1
            echo "Error found in ${myfile}:"
            echo "Error found in ${myfile}:" >> $logfile
            echo "$result"
            echo "$result" >> $logfile
            echo ""
            echo "" >> $logfile
            echo "======================================================="
            echo "=======================================================" >> $logfile
        fi
     fi
done

if [[ $errorfound = 1 ]]; then
   cat $logfile | mailx -s "[Revenue Assurance] Exceptions encountered in the logs (${MODULE})" $MAILTO
else
        echo " No Exception found"
        echo " No Exception found" >> $logfile
        echo "======================================================="
        echo "=======================================================" >> $logfile
fi

}
